<template>
  <SidebarLayout>
    <template v-slot:sidebar>
      <div class="project-details">
        <b-img blank width="48" height="48" blankColor="#777" rounded alt="Rounded image"></b-img>
        <div class="project-details-text">
          <div class="name">{{ project.name }}</div>
          <div class="project-type">{{ project.project_type }} project</div>
        </div>
      </div>
      
      <SidebarNav>
        <SidebarNavItem 
          text="Add New"
          icon="plus"
          v-b-modal="'create-new-issue-modal'"
        />
        <SidebarNavItem 
          text="Kanban Board"
          icon="kanban"
          :link="{ name: 'IssuesProjectBoards', params: { identifier: identifier } }"
          :active="sidebarActiveKey == 'boards'"
        />
        <SidebarNavItem 
          text="Issues List" 
          icon="list-check" 
          :link="{ name: 'IssuesProjectIssuesList', params: { identifier: identifier }  }"
          :active="sidebarActiveKey == 'list'"
        />
        <SidebarNavItem 
          text="Releases"
          icon="flag"
          :link="{ name: 'IssuesProjectReleases', params: { identifier: identifier }  }"
          :active="sidebarActiveKey == 'releases'"
        />
        <SidebarNavItem
          text="Roadmap"
          icon="kanban"
          :link="{ name: 'IssuesProjectRoadmap', params: { identifier: identifier }  }"
          :active="sidebarActiveKey == 'roadmap'"
        />
        <SidebarNavItem 
          text="Reports"
          icon="graph-down"
          :link="{ name: 'IssuesProjectReports', params: { identifier: identifier }  }"
          :active="sidebarActiveKey == 'reports'"
        />
        <SidebarNavItem 
          text="Project Settings"
          icon="gear"
          :link="{ name: 'IssuesProjectSettings', params: { identifier: identifier }  }"
          :active="sidebarActiveKey == 'settings'" 
        />
      </SidebarNav>
    </template>

    <template v-slot:content>
      <router-view v-on:setSidebarActive="onSetSidebarActive" />
    </template>
  </SidebarLayout>
</template>

<script>
import { mapState } from 'vuex'
import SidebarLayout from '@/components/Layout/SidebarLayout'
import SidebarNav from '@/components/Layout/SidebarNav'
import SidebarNavItem from '@/components/Layout/SidebarNavItem'

import { BIcon, BIconKanban, BIconGar, BIconGraphDown, BIconListCheck, BIconPlus, BIconFlag } from 'bootstrap-vue'

export default {
  name: 'IssuesProjectView',
  components: {
    SidebarLayout,
    SidebarNav,
    SidebarNavItem,
    BIcon
  },
  data() {
    return {
      sidebarActiveKey: ''
    }
  },
  computed: mapState({
    identifier() {
      return this.$store.getters['issues/projects/getIdentifierByParams'](this.$route.params);
    },
    project() {
      return this.$store.getters['issues/projects/getProjectDetailsByParams'](this.$route.params);
    }
  }),
  created () {
    this.$store.dispatch('issues/projects/getProjectByParams', this.$route.params);
  },
  methods: {
    onSetSidebarActive(value) {
      this.sidebarActiveKey = value;
    }
  }
}
</script>

<style scoped lang="scss">
.side-nav-card {
  .project-details {
    img {
      vertical-align: top;
    }
    .project-details-text {
      display: inline-block;
      margin-left: 8px;

      .name {
        font-weight: 500;
        font-size: 1.2rem;
      }
      .project-type {
        font-size: 0.8rem;
        font-weight: 200;;
      }
    }
  }
}
</style>